#include <iostream>
#include<vector>
#include<limits>
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    int n,k,x;
    cin>>n>>k>>x;
    if(x==2){

    long long sum=0;
    vector<int>p(n);
    vector<long long> matf(n);
    //cout<<"brek";
    for(int i=0;i<n;i++){
        cin>>p[i];
        sum+=p[i];
        matf[i]=sum;

    }
    /*
    for(int i=0;i<n;i++){
        cout<<matf[i];
    }
    */
    vector<int>ans(n-k+1);
    for(int i=0;i<n-k+1;i++){
        long long base=matf[i+k-1]-((i>0)?matf[i-1]:0);
        //cout<<"BASE: "<<base;
        //long long mx=base+p;
        long long best=INT_MIN;
        for(int j=0;j<k;j++){
            long long add=matf[i+k-1]-matf[i+k-j-1];
            //cout<<"\nADD:"<<add<<" ";
            best=max(best,base+add);
        }
        ans[i]=best;
    }
    for(int i=0;i<n-k+1;i++){
        cout<<ans[i]<<" ";
    }
    }else{

    vector<int>p(n);
    for(int i=0;i<n;i++){
        cin>>p[i];
    }
    vector<int>ans(n-k+1);
    for(int i=0;i<n-k+1;i++){
        for(int j=i;j<i+k;j++){
            ans[i]+=min(j-i+1,x)*p[j];
        }
    }
    for(int i=0;i<n-k+1;i++){
        cout<<ans[i]<<" ";
    }
    }
}